commit 748ae964f6fe39d07b88830201de268a16b9694b
Author: freddy77 <freddy77>
Date:   Sat Dec 20 19:16:31 2008 +0000

    fix quite impossible memory leak

diff --git a/ChangeLog b/ChangeLog
index 66f10b3..8955590 100644
--- a/ChangeLog
+++ b/ChangeLog
@@ -1,3 +1,6 @@
+Sat Dec 20 20:16:20 CET 2008    Frediano Ziglio <freddy77_A_gmail_D_com>
+	* src/tds/mem.c: fix quite impossible memory leak
+
 Sat Dec 20 20:13:33 CET 2008    Frediano Ziglio <freddy77_A_gmail_D_com>
 	* misc/commit: fix small problem with small comments
 
@@ -1135,4 +1138,4 @@ Wed Jan  9 19:54:43 EST 2008	JK Lowden <jklowden@freetds.org>
 	* ChangeLog  truncated because of release
 	* ChangeLog-0.82 added because of release
 	
-$Id: ChangeLog,v 1.2696 2008/12/20 19:13:41 freddy77 Exp $
+$Id: ChangeLog,v 1.2697 2008/12/20 19:16:31 freddy77 Exp $
diff --git a/src/tds/mem.c b/src/tds/mem.c
index b0edbf7..730f70d 100644
--- a/src/tds/mem.c
+++ b/src/tds/mem.c
@@ -41,7 +41,7 @@
 #include <dmalloc.h>
 #endif
 
-TDS_RCSID(var, "$Id: mem.c,v 1.183 2008/12/20 06:01:21 jklowden Exp $");
+TDS_RCSID(var, "$Id: mem.c,v 1.184 2008/12/20 19:16:31 freddy77 Exp $");
 
 static void tds_free_env(TDSSOCKET * tds);
 static void tds_free_compute_results(TDSSOCKET * tds);
@@ -948,7 +948,7 @@ tds_release_cursor(TDSSOCKET *tds, TDSCURSOR *cursor)
 TDSLOGIN *
 tds_alloc_login(void)
 {
-	TDSLOGIN *tds_login;
+	TDSLOGIN *tds_login = NULL;
 	const char *server_name = "SYBASE";
 	char *s;
 	
@@ -970,12 +970,14 @@ tds_alloc_login(void)
 	if ((s=getenv("TDSQUERY")) != NULL)
 		server_name = s;
 
-	tds_dstr_copy(&tds_login->server_name, server_name);
+	if (!tds_dstr_copy(&tds_login->server_name, server_name))
+		goto Cleanup;
 	memcpy(tds_login->capabilities, defaultcaps, TDS_MAX_CAPABILITY);
 
 	return tds_login;
 
       Cleanup:
+	free(tds_login);
 	return NULL;
 }
 

